enum StreamType
{
	MESSAGE,
	SCORE,
	FREQUENCYCHECK
}

enum Instruction
{
	SHOW,
	HIDE,
	UPDATE
}

enum MessageType
{
	REGISTER,
	ENTERKEY,
	LOGIN,
	PING,
	FPS
}

message	<- null;
score	<- null;

sX <- GUI.GetScreenSize().X;
sY <- GUI.GetScreenSize().Y;


Script.LoadScript("message.nut");
Script.LoadScript("frequencycheck.nut");
Script.LoadScript("score.nut");

function Script::ScriptUnload()
{	
	if(message)
	{
		message.Clean();
		::message = null;
	}
}

function Server::ServerData( stream )
{
	try
	{
		local type = stream.ReadByte();
		
		switch( type )
		{
			case StreamType.MESSAGE:
			{
				local instruction = stream.ReadByte();
				local messageType = stream.ReadByte();
				
				if( instruction == Instruction.SHOW )
				{
					if( ::message )
					{
						::message.Clean();
						::message = null;
					}
					::message = ::CMessage( messageType );
				}
				
				else if( instruction == Instruction.HIDE )
				{
					if( message )
					{
						message.Clean();
						::message = null;
					}
				}
			
				else
					throw("invalid action ID given at StreamType.MESSAGE");
					
				break;
			}
			
			case StreamType.SCORE:
			{
				local cubanScore 	= stream.ReadInt();
				local haitianScore 	= stream.ReadInt();
				
				if( ::score )
				{
					::score.Clean();
					::score = null;
				}
				::score = ::CScore(cubanScore, haitianScore);
					
				break;
			}
			
			default:
				throw("invalid type ID received in Stream");
		}
	}
	catch(e)
	{
		Console.Print("[#B60000]An error occurred at Server::ServerData(): " + e + ". Please contact a developer.");
	}
}