enum TextSlot
{
	TOP,
	MIDDLE,
	BOTTOM
}

class CMessage
{
	labels	= {};
	x		= 0;
	y		= 0;
	
	constructor( type )
	{
		try
		{
			switch( type )
			{
				case MessageType.REGISTER:
				{
					this.DisplayMessage( TextSlot.TOP, "This event is for registered participants only. Please register yourself on www.viceunderdogs.com");
					this.DisplayMessage( TextSlot.MIDDLE, "Ye event sirf registered users ke liye hai. Barahe Merbani www.viceunderdogs.com pe ja ke register karen.");
					this.DisplayMessage( TextSlot.BOTTOM, "Este evento es solo para participantes registrados. Por favor, registrarse en www.viceunderdogs.com");
					break;
				}
				
				case MessageType.ENTERKEY:
				{
					this.DisplayMessage( TextSlot.TOP, "Welcome to Vicewar 6!");
					this.DisplayMessage( TextSlot.MIDDLE, "To complete the registration, we need the private key sent to you on the VU forum.");
					this.DisplayMessage( TextSlot.BOTTOM, "Type /register <key> <New Password> to register.");
					break;
				}
				
				case MessageType.LOGIN:
				{
					this.DisplayMessage( TextSlot.TOP, "Welcome back to Vicewar 6!");
					this.DisplayMessage( TextSlot.MIDDLE, "Please login to continue. /login <Your Password>");
					break;
				}
				
				case MessageType.PING:
				{
					this.DisplayMessage( TextSlot.BOTTOM, "Your ping is high. Stop moving to avoid a kick.");
					break;
				}
				
				case MessageType.FPS:
				{
					this.DisplayMessage( TextSlot.BOTTOM, "Your FPS is low. Stop moving to avoid a kick.");
					break;
				}
			}
		}
		catch( e )
			::Console.Print("[#B60000]An error occurred at CMessage::constructor(): " + e + ". Please contact a developer.");
	}
	
	function DisplayMessage( slot, message )
	{
		try
		{
			switch( slot )
			{
				case TextSlot.TOP:
					this.y = sY - floor(sY/2.4);
					break;
				case TextSlot.MIDDLE:
					this.y = sY - floor(sY/3);
					break;
				case TextSlot.BOTTOM:
					this.y = sY - floor(sY/4);
					break;
			}
			
			this.x = ( (sX - message.len()* floor(sX/170) )/2 );
			local label = ::GUILabel( ::VectorScreen( this.x, this.y ), Colour(255, 255, 255), message );
			
			label.FontSize 		= floor(sX/85);
			label.FontFlags     = GUI_FFLAG_OUTLINE | GUI_FFLAG_BOLD;
			label.TextAlignment = GUI_ALIGN_LEFT;
			label.SendToTop();
			
			this.labels.rawset( slot, label );
		}
		catch(e)
			::Console.Print("[#B60000]An error occurred at CMessage::DisplayMessage(): " + e + ". Please contact a developer.");
	}
	
	function Clean()
	{
		foreach( idx, label in this.labels )
		{
			label= null;
			this.labels.rawdelete( idx );
		}
	}
}